//*****************************************************************************
//*****************************************************************************
//  FILENAME: WirelessUSBLS_1.h
//   Version: 1.0, Updated on 2008/6/23 at 12:26:35
//  Generated by PSoC Designer ???
//
//  DESCRIPTION:
//    WirelessUSBLS_1 WirelessUSBLS User Module header file.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

//--------------------------------------------------
// Register constants and masks
//--------------------------------------------------

#define REG_ID                 0x00
#define VERSION_MASK           0x0F
#define MANUFACTURING_MASK     0xF0
                                
#define REG_SYNTH_A_CNTR       0x01  
#define REG_SYNTH_N_CNTR       0x02
                                
#define REG_CONTROL            0x03    
#define RX_ENABLE              0x80    
#define TX_ENABLE              0x40    
#define PN_CODE_SELECT         0x20    
#define AUTO_SYNTH_COUNT       0x10
#define AUTO_PA_DISABLE        0x08
#define PA_ENABLE              0x04
#define AUTO_SYNTH_DISABLE     0x02
#define SYNTH_ENABLE           0x01
                                
#define REG_DATA_RATE          0x04    
#define RADIO_MODE_NORM        0x00
#define CHIP_BITS_32           0x04
#define CHIP_BITS_64           0x00
#define NORMAL_DATA_RATE       0x00
#define DOUBLE_DATA_RATE       0x02
#define OVERSAMPLING_6X        0x00
#define OVERSAMPLING_12X       0x01
                                
#define REG_CONFIG             0x05    
#define RADIO_BYPASS           0x20
#define RX_INVERT              0x10
#define TX_INVERT              0x08
#define IRQ_OD                 0x02
#define IRQ_CMOS               0x00
#define IRQ_ACTIVE_HI          0x01
#define IRQ_ACTIVE_LO          0x00
                                
#define REG_SERDES_CTL         0x06    
#define SERDES_ENABLE          0x08
#define EOF_LEN_MASK           0x07
                                
#define REG_RX_INT_EN          0x07
#define RX_UNDER_B             0x80    
#define RX_OVER_B              0x40    
#define RX_EOF_B               0x20    
#define RX_FULL_B              0x10    
#define RX_UNDER_A             0x08    
#define RX_OVER_A              0x04    
#define RX_EOF_A               0x02    
#define RX_FULL_A              0x01    
                                
#define REG_RX_INT_STAT        0x08
#define RX_VALID_B             0x80    
#define RX_VALID_A             0x08    
// other bits same as above (almost)           

#define REG_DATA_RX_A          0x09
#define REG_VALID_RX_A         0x0A
#define REG_DATA_RX_B          0x0B
#define REG_VALID_RX_B         0x0C
                               
#define REG_TX_INT_EN          0x0D
#define TX_UNDER               0x08
#define TX_OVER                0x04
#define TX_EOF                 0x02
#define TX_EMPTY               0x01
//bits same as REG_RX_INT_EN except LSb of each nibble

#define REG_TX_INT_STAT        0x0E
// bits same as above                      

#define REG_DATA_TX            0x0F
#define REG_VALID_TX           0x10

#define REG_PN_CODE            0x11    
//Address 0x11 is LSB, 0x18 is MSB            
//Transmit and receive LSB first              

#define REG_THRESHOLD_LO       0x19    
#define REG_THRESHOLD_HI       0x1A    
#define THRESHOLD_MASK         0x7F

#define REG_THRESHOLD_CNT      0x1B    // read only

#define REG_WAKE_EN            0x1C    
#define WAKE_EN                0x01    

#define REG_WAKE_STAT          0x1D    
#define WAKE_INT               0x01    // bWAKE_STAT

//Registers 0x1C - 0x1F are Reserved          
#define REG_ANALOG_CTL         0x20    
#define AGC_RSSI_CTL           0x40    
#define MID_READ_EN            0x20    
#define PACTL_EN               0x04
#define PACTL_INVERT           0x02
#define SYSTEM_RESET           0x01

#define REG_CHANNEL            0x21
#define A_N_EN                 0x80    
#define CHANNEL_MASK           0x7F

#define REG_RSSI               0x22
#define RSSI_VALID             0x20
#define RSSI_MASK              0x1F

#define REG_PA                 0x23    
#define PA_BIAS_MASK           0x07

#define REG_XTAL_ADJ           0x24
#define CLOCK_DISABLE          0x40
#define XTAL_ADJ_MASK          0x3F

#define REG_CAL_COUNT          0x25

#define REG_VCO_CAL            0x26
#define MINUS_5_PLUS_5         0xC0
#define MINUS_2_PLUS_3         0x80
#define VCO_CAL_MASK           0x1F

#define REG_AGC_CTL            0x2E
#define AGC_OFF                0x80

#define REG_CARRIER_DETECT     0x2F
#define CDET                   0x80

#define REG_CLOCK_MANUAL       0x32

#define REG_CLOCK_ENABLE       0x33

#define REG_SYN_LOCK_CNT       0x38    

#define REG_MFG_ID_1           0x3C    // REG_MFG_ID
#define REG_MFG_ID_2           0x3D
#define REG_MFG_ID_3           0x3E
#define REG_MFG_ID_4           0x3F


//-------------------------------------------------
// Prototypes of the Wireless USB radio API.
//-------------------------------------------------

#define WirelessUSBLS_1_DATA_RATE              ( 0x10 )
#define WirelessUSBLS_1_CRYSTAL_ADJUST         ( 0x0 )
#define WirelessUSBLS_1_CRYSTAL_STARTUP_TIME   ( 0x3 )
#define WirelessUSBLS_1_TX_POWER_LEVEL         ( 0x7 ) 
#define WirelessUSBLS_1_CHIP_ERROR_THRESHOLD   ( 0x3 ) 
#define WirelessUSBLS_1_EOF_BITS               ( 0x3 )  
#define WirelessUSBLS_1_NON_BLOCKING_CALLS     ( 0x0 ) 
                                                        

//-------------------------------------------------
// Prototypes of the Wireless USB radio API.
//-------------------------------------------------
#pragma fastcall16 WirelessUSBLS_1_Start
#pragma fastcall16 WirelessUSBLS_1_SetChannel
#pragma fastcall16 WirelessUSBLS_1_SetPnCode
#pragma fastcall16 WirelessUSBLS_1_SendData
#pragma fastcall16 WirelessUSBLS_1_bReadData
#pragma fastcall16 WirelessUSBLS_1_bCheckRxInt
#pragma fastcall16 WirelessUSBLS_1_bCheckRxInProgress
#pragma fastcall16 WirelessUSBLS_1_StartNonBlockingRead
#pragma fastcall16 WirelessUSBLS_1_StopNonBlockingRead
#pragma fastcall16 WirelessUSBLS_1_GetMid
#pragma fastcall16 WirelessUSBLS_1_bGetRssi
#pragma fastcall16 WirelessUSBLS_1_SetTxPowerLevel
#pragma fastcall16 WirelessUSBLS_1_bGetTxPowerLevel
#pragma fastcall16 WirelessUSBLS_1_Sleep
#pragma fastcall16 WirelessUSBLS_1_Wakeup

#pragma fastcall16 WirelessUSBLS_1_bReadRegister
#pragma fastcall16 WirelessUSBLS_1_WriteRegister

extern void WirelessUSBLS_1_Start(void);
extern void WirelessUSBLS_1_SetChannel(BYTE bChannel);
extern void WirelessUSBLS_1_SetPnCode(const BYTE * pbPnCode);
extern void WirelessUSBLS_1_SendData(BYTE bLength, BYTE * pbData);
extern BYTE WirelessUSBLS_1_bReadData(BYTE bLength, BYTE * pbData, BYTE * pbValid, WORD wTimeout);
extern void WirelessUSBLS_1_StartNonBlockingRead(BYTE bLength, BYTE * pbData, BYTE * pbValid);
extern void WirelessUSBLS_1_StopNonBlockingRead(void);
extern BYTE WirelessUSBLS_1_bCheckRxInt(void);
extern BYTE WirelessUSBLS_1_bCheckRxInProgress(void);

extern void WirelessUSBLS_1_Sleep(void);
extern void WirelessUSBLS_1_Wakeup(void);

extern void WirelessUSBLS_1_GetMid(BYTE * pbMid);
extern BYTE WirelessUSBLS_1_bGetRssi(void);
extern void WirelessUSBLS_1_SetTxPowerLevel(BYTE bPowerLevel);
extern BYTE WirelessUSBLS_1_bGetTxPowerLevel(void);

extern BYTE WirelessUSBLS_1_bReadRegister(BYTE bRegister);
extern void WirelessUSBLS_1_WriteRegister(BYTE bRegister, BYTE bData);

// end of file WirelessUSBLS_1.h
