;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: WirelessUSBLS_1.inc
;;   Version: 1.0, Updated on 2008/6/23 at 12:26:35
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION:
;;    Assembler include file of WirelessUSBLS_1 instance of WirelessUSBLS
;;    user module.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************


;-----------------------------------------------
;  User Defined Parameters
;-----------------------------------------------

WirelessUSBLS_1_DATA_RATE:                      equ 10h 
WirelessUSBLS_1_CRYSTAL_STARTUP_TIME:           equ 3h 
WirelessUSBLS_1_CRYSTAL_ADJUST:                 equ 0h 
WirelessUSBLS_1_TX_POWER_LEVEL:                 equ 7h 
WirelessUSBLS_1_CHIP_ERROR_THRESHOLD:           equ 3h 
WirelessUSBLS_1_EOF_BITS:                       equ 3h  
WirelessUSBLS_1_NON_BLOCKING_CALLS:             equ 0h 


;-----------------------------------------------
;  Constant Definitions
;-----------------------------------------------
                                       
RADIO_SYNTH_LOCK_COUNT:            equ 100

RADIO_MODE_IDLE:                   equ 0
RADIO_MODE_RX:                     equ 1
RADIO_MODE_TX:                     equ 2

; PORT 0
MISO_PIN:       equ     02h
SCLK_PIN:       equ     08h
NRESET_PIN:     equ     10h
MOSI_PIN:       equ     20h  
IRQ_PIN:        equ     40h
NSS_PIN:        equ     80h

; PORT 1
NPD_PIN:        equ     08h     

RX_DONE:               equ 1
RX_NO_BLOCK:           equ 2
RX_OVER:               equ 8

WirelessUSBLS_1_CHANNEL_OFFSET:   equ 2h ; This is setup to ensure a guard ban at the low end
                                          ; Channel 0  - 2.402, a 2 MHz guard band to 2.400
                                          ; The upper guard band is protected by the use of
                                          ; NUM_CHANNELS in the protocol and application
                                          ; Channel 78 - 2.480, a 3.5MHz guard to 2.4835

IF    ( WirelessUSBLS_1_DATA_RATE & 10h )
RADIO_MODE:     equ    CHIP_BITS_64 | NORMAL_DATA_RATE
NUM_CHIPS:      equ    64
ENDIF ; DATA_RATE_16

IF    ( WirelessUSBLS_1_DATA_RATE & 40h )
RADIO_MODE:     equ    CHIP_BITS_32 | DOUBLE_DATA_RATE
NUM_CHIPS:      equ    32
ENDIF ; DATA_RATE_64

      
;--------------------------------------------------
; Pin Equates and masks
;--------------------------------------------------

; MISO address and mask equates
MISO_Data_ADDR:          equ     00h
MISO_DriveMode_0_ADDR:   equ     0100h
MISO_DriveMode_1_ADDR:   equ     0101h
MISO_DriveMode_2_ADDR:   equ     03h
MISO_IntEn_ADDR:         equ     01h
MISO_MASK:               equ     02h

; nRESET address and mask equates
nRESET_Data_ADDR:        equ     00h
nRESET_DriveMode_0_ADDR: equ     0100h
nRESET_DriveMode_1_ADDR: equ     0101h
nRESET_DriveMode_2_ADDR: equ     03h
nRESET_IntEn_ADDR:       equ     01h
nRESET_MASK:             equ     10h

; nPD address and mask equates
nPD_Data_ADDR:           equ     04h
nPD_DriveMode_0_ADDR:    equ     0104h
nPD_DriveMode_1_ADDR:    equ     0105h
nPD_DriveMode_2_ADDR:    equ     07h
nPD_IntEn_ADDR:          equ     05h
nPD_MASK:                equ     08h

;IRQ address and mask equates
IRQ_Data_ADDR:           equ     00h
IRQ_DriveMode_0_ADDR:    equ     0100h
IRQ_DriveMode_1_ADDR:    equ     0101h
IRQ_DriveMode_2_ADDR:    equ     03h
IRQ_IntEn_ADDR:          equ     01h
IRQ_MASK:                equ     40h
   
;--------------------------------------------------
; Register constants and masks
;--------------------------------------------------

REG_ID:              equ   00h
VERSION_MASK:        equ   0Fh
MANUFACTURING_MASK:  equ   F0h
                             
REG_SYNTH_A_CNTR:    equ   01h  
REG_SYNTH_N_CNTR:    equ   02h
                             
REG_CONTROL:         equ   03h    
RX_ENABLE:           equ   80h    
TX_ENABLE:           equ   40h    
PN_CODE_SELECT:      equ   20h    
AUTO_SYNTH_COUNT:    equ   10h
AUTO_PA_DISABLE:     equ   08h
PA_ENABLE:           equ   04h
AUTO_SYNTH_DISABLE:  equ   02h
SYNTH_ENABLE:        equ   01h
                             
REG_DATA_RATE:       equ   04h    
RADIO_MODE_NORM:     equ   00h
CHIP_BITS_32:        equ   04h
CHIP_BITS_64:        equ   00h
NORMAL_DATA_RATE:    equ   00h
DOUBLE_DATA_RATE:    equ   02h
OVERSAMPLING_6X:     equ   00h
OVERSAMPLING_12X:    equ   01h
                                                          
REG_CONFIG:          equ   05h    
RADIO_BYPASS:        equ   20h
RX_INVERT:           equ   10h
TX_INVERT:           equ   08h
IRQ_OD:              equ   02h
IRQ_CMOS:            equ   00h
IRQ_ACTIVE_HI:       equ   01h
IRQ_ACTIVE_LO:       equ   00h
                             
REG_SERDES_CTL:      equ   06h    
SERDES_ENABLE:       equ   08h
EOF_LEN_MASK:        equ   07h
                             
REG_RX_INT_EN:       equ   07h
RX_UNDER_B:          equ   80h    
RX_OVER_B:           equ   40h    
RX_EOF_B:            equ   20h    
RX_FULL_B:           equ   10h    
RX_UNDER_A:          equ   08h    
RX_OVER_A:           equ   04h    
RX_EOF_A:            equ   02h    
RX_FULL_A:           equ   01h    
                             
REG_RX_INT_STAT:     equ   08h
RX_VALID_B:          equ   80h    
RX_VALID_A:          equ   08h    
; other bits same as above (almost)           
                                              
REG_DATA_RX_A:       equ   09h
REG_VALID_RX_A:      equ   0Ah
REG_DATA_RX_B:       equ   0Bh
REG_VALID_RX_B:      equ   0Ch
                             
REG_TX_INT_EN:       equ   0Dh
TX_UNDER:            equ   08h
TX_OVER:             equ   04h
TX_EOF:              equ   02h
TX_EMPTY:            equ   01h
;bits same as REG_RX_INT_EN except LSb of each nibble
                                         
REG_TX_INT_STAT:     equ   0Eh
; bits same as above                          
                             
REG_DATA_TX:         equ   0Fh
REG_VALID_TX:        equ   10h
                             
REG_PN_CODE:         equ   11h    
;Address 0x11 is LSB, 0x18 is MSB             
;Transmit and receive LSB first               
                                              
REG_THRESHOLD_LO:    equ   19h    
REG_THRESHOLD_HI:    equ   1Ah    
THRESHOLD_MASK:      equ   7Fh
                             
REG_THRESHOLD_CNT:   equ   1Bh    ; read only
                             
REG_WAKE_EN:         equ   1Ch    
WAKE_EN:             equ   01h    
                             
REG_WAKE_STAT:       equ   1Dh    
WAKE_INT:            equ   01h    ; bWAKE_STAT
                                                                                          
;Registers 0x1C - 0x1F are Reserved           
REG_ANALOG_CTL:      equ   20h    
AGC_RSSI_CTL:        equ   40h    
MID_READ_EN:         equ   20h    
PACTL_EN:            equ   04h
PACTL_INVERT:        equ   02h
SYSTEM_RESET:        equ   01h
                             
REG_CHANNEL:         equ   21h
A_N_EN:              equ   80h    
CHANNEL_MASK:        equ   7Fh
                             
REG_RSSI:            equ   22h
RSSI_VALID:          equ   20h
RSSI_MASK:           equ   1Fh
                             
REG_PA:              equ   23h    
PA_BIAS_MASK:        equ   07h
                             
REG_XTAL_ADJ:        equ   24h
CLOCK_DISABLE:       equ   40h
XTAL_ADJ_MASK:       equ   3Fh
                             
REG_CAL_COUNT:       equ   25h
                             
REG_VCO_CAL:         equ   26h
MINUS_5_PLUS_5:      equ   C0h
MINUS_2_PLUS_3:      equ   80h
VCO_CAL_MASK:        equ   1Fh
                             
REG_AGC_CTL:         equ   2Eh
AGC_OFF:             equ   80h
                             
REG_CARRIER_DETECT:  equ   2Fh
CDET:                equ   80h
                             
REG_CLOCK_MANUAL:    equ   32h
                             
REG_CLOCK_ENABLE:    equ   33h
                             
REG_SYN_LOCK_CNT:    equ   38h    
                             
REG_MFG_ID_1:        equ   3Ch    ; REG_MFG_ID
REG_MFG_ID_2:        equ   3Dh
REG_MFG_ID_3:        equ   3Eh
REG_MFG_ID_4:        equ   3Fh

; end of file WirelessUSBLS_1.inc
