//----------------------------------------------------------------------------
// 	WirelessUSBサンプルプログラム
// 8バイト受信して先頭バイトの最下位ビットでLEDをON/OFF
// （'1'なら点灯、'0'なら消灯）
// LEDはP1[2]で'1'で点灯
//----------------------------------------------------------------------------

#include <m8c.h>
#include "PSoCAPI.h"
#include "psocgpioint.h"

#define	RX_TIMEOUT	40000	// 15usec単位の受信タイムアウト時間
#define WUSB_CHANNEL	30	// 使用チャンネル（ここでは＃30）
#define	WUSB_PNCODE	0x08	// 使用するPNコード（8バイト）の先頭位置

#define LEDBIT		0x04
const BYTE pn_code_table[] = {
0x36, 0xF3, 0x8C, 0xB5, 0x11, 0x4A, 0xCA, 0x1F,
};

#define	TRXSIZE	8
unsigned char	rxval[TRXSIZE],valid[TRXSIZE];
unsigned char PORT1DATA;

void main()
{
	unsigned char c,d;
	WirelessUSBLS_1_Start();
	WirelessUSBLS_1_SetChannel(WUSB_CHANNEL);
	WirelessUSBLS_1_SetPnCode(pn_code_table);
	M8C_EnableGInt;
	c = 0xff;
	PORT1DATA = PRT1DR & ~LEDBIT;
	PRT1DR = PORT1DATA;
	while(1) {
		// ワイヤレスUSB受信
		if (WirelessUSBLS_1_bReadData(TRXSIZE, (BYTE *)&rxval, (BYTE *)&valid, RX_TIMEOUT)==RXBUFSIZE) {
			d = 0; 
			for (c=0; c<TRXSIZE; c++) {	// Validチェック
				if (valid[0] != 0xff) {
					d = 1;
					break;
				}
			}
			if (d == 0) {	// 全ビット（ここでは１バイト）が有効ならLED表示
				if (rxval[0] & 1) {
					PORT1DATA |= LEDBIT;
				} else {
					PORT1DATA &= ~LEDBIT;
				}
				PRT1DR = PORT1DATA;
			}
		}
	}
}
